var health_min = 0;
var health_max = 0;
function damage( event ) {
	var line = remascii( event );
	var min_hit = 0;
	var max_hit = 0;
	var erad = 0;
	if (line.search(/ tickl(ing|es)/) != -1) {
		var min_hit = 1;
		var max_hit = 5;
	} else if (line.search(/ graz(ing|es)? /) != -1) {
		var min_hit = 6;
		var max_hit = 10;
	} else if (line.search(/ scratch(ing|es)? /) != -1) {
		var min_hit = 11;
		var max_hit = 20;
	} else if (line.search(/ bruis(ing|es)? /) != -1) {
		var min_hit = 21;
		var max_hit = 30;
	} else if (line.search(/ sting(ing|es)? /) != -1) {
		var min_hit = 31;
		var max_hit = 40;
	} else if (line.search(/ wound(ing|es)? /) != -1) {
		var min_hit = 41;
		var max_hit = 50;
	} else if (line.search(/ shend(ing|es)? /) != -1) {
		var min_hit = 51;
		var max_hit = 75;
	} else if (line.search(/ scath(ing|es)? /) != -1) {
		var min_hit = 76;
		var max_hit = 100;
	} else if (line.search(/ pummel(ling|es)? /) != -1) {
		var min_hit = 101;
		var max_hit = 125;
	} else if (line.search(/ batter(E|ing|es)? /) != -1) {
		var min_hit = 126;
		var max_hit = 150;
	} else if (line.search(/ splinter(ing|es)? /) != -1) {
		var min_hit = 151;
		var max_hit = 200;
	} else if (line.search(/ disfigur(ing|es)? /) != -1) {
		var min_hit = 201;
		var max_hit = 250;
	} else if (line.search(/ fractur(ing|es)? /) != -1) {
		var min_hit = 251;
		var max_hit = 300;
	} else if (line.search(/ lacerat(ing|es)? /) != -1) {
		var min_hit = 301;
		var max_hit = 400;
	} else if (line.search(/ RUPTUR(E|ING|ES)? /) != -1) {
		var min_hit = 401;
		var max_hit = 500;
	} else if (line.search(/ MUTILAT(E|ING|ES)? /) != -1) {
		var min_hit = 501;
		var max_hit = 750;
	} else if (line.search(/ DEHISC(E|ING|ES)? /) != -1) {
		var min_hit = 751;
		var max_hit = 1000;
	} else if (line.search(/ MAIM(ING|S)? /) != -1) {
		var min_hit = 1001;
		var max_hit = 1250;
	} else if (line.search(/ DISMEMBER(ING|S)? /) != -1) {
		var min_hit = 1251;
		var max_hit = 1500;
	} else if (line.search(/ SUNDER(ING|S)? /) != -1) {
		var min_hit = 1501;
		var max_hit = 1750;
	} else if (line.search(/ CREMAT(E|ING|ES)? /) != -1) {
		var min_hit = 1751;
		var max_hit = 2000;
	} else if (line.search(/ EVISCERAT(E|ING|ES)? /) != -1) {
		var min_hit = 2001;
		var max_hit = 2500;
	} else if (line.search(/ RAVAG(ING|ES)? /) != -1) {
		var min_hit = 2501;
		var max_hit = 3000;
	} else if (line.search(/ IMMOLAT(E|ING|ES)? /) != -1) {
		var min_hit = 3001;
		var max_hit = 3500;
	} else if (line.search(/ LIQUIF(y|YING|IES)? /) != -1) {
		var min_hit = 3501;
		var max_hit = 4000;
	} else if (line.search(/ VAPORIZ(E|ING|ES)? /) != -1) {
		var min_hit = 4001;
		var max_hit = 4500;
	} else if (line.search(/ ATOMIZ(E|ING|ES)? /) != -1) {
		var min_hit = 4501;
		var max_hit = 5000;
	} else if (line.search(/ OBLITERAT(E|ING|ES)? /) != -1) {
		var min_hit = 5001;
		var max_hit = 6000;
	} else if (line.search(/ ETHEREALIZ(E|ING|ES)? /) != -1) {
		var min_hit = 6001;
		var max_hit = 7000;
	} else if (line.search(/ ERADICAT(E|ING|ES)? /) != -1) {
		var min_hit = 7001;
		var max_hit = 7002;
		var erad = 1;
	}
	if (min_hit != 0) {
		var expression = /\[ (\d+) of (\d+) ]/;
		var re = new RegExp( expression );
		var m = re.exec( line );
		
		var re = new RegExp( /\((\d+)\)/ );
		var match = re.exec( line );
		
		if (m != null) {
			min_hit = min_hit * m[ 1 ];
			max_hit = max_hit * m[ 1 ];
		}
		if (match != null) {
			var hits = 1;
			if (m != null)
				hits = m[ 1 ];
			var damage = match[ 1 ] * hits;
			var replace = "[ [1;37m" + damage + " [0;37m] " + event;
			health_min += damage;
			health_max += damage;
		} else {	
			if (!erad) {
				var replace = "[ [1;37m" + min_hit + " - " + max_hit + " [0;37m] " + event;
			} else {
				var replace = "[ [1;37m" + min_hit + " - " + max_hit + "+ [0;37m] " + event;
			}
			health_min += min_hit;
			health_max += max_hit;
		}
		return replace;
	} else if (line.search("falls to the ground!") != -1 || line == "You hear the screams of a spirit as it flies by you.") {
		jmc.showme("(Total Mob HP: " + health_min + " - " + health_max + ")");
		health_min = 0;
		health_max = 0;
	}
	return event;
}

register_handler("Incoming", damage);