var grouper_enabled = 0;
var grouper_grouped = new Array();
var grouper_validate = new Array();
var grouper_queued = new Array();

var grouper_tell = new RegExp( /[< mentor >\s|< guard >\s]?(\w+) tells you, 'can i [join|follow].*'$/i );
var grouper_fol_start = new RegExp( /^(.*) starts following you.$/ );
var grouper_fol_stop = new RegExp( /^(.*) stops following you.$/ );

var grouper_check = new Date();

function grouper_output( event ) {
	line = remascii( event );
	
	if (grouper_enabled) {
		if ((match = grouper_tell.exec( line )) != null) {
			var found = false;
			for (var x = 0; x < grouper_validate.length ; x++) {
				if (match[ 1 ] == grouper_validate[ x ][ 0 ]) {
					found = true;
				}
			}
			
			for (var x = 0; x < grouper_grouped.length ; x++) {
				if (match[ 1 ] == grouper_grouped[ x ]) {
					found = true;
				}
			}
			if (!found) {
				if ((grouper_grouped.length + grouper_validate.length) < 8) {
					grouper_validate.push( new Array( match[ 1 ], new Date() ) );
					jmc.output( color( 1,"yellow") + match[ 1 ] + " added to validation of group");
					jmc.parse( "tell " + match[ 1 ] + " You have been added to my queue list, you have 1 minute to follow or you will be removed from the list." );
				} else {
					jmc.parse( "tell " + match[ 1 ] + " I'm sorry, but the current group i have is full. You will be contacted when another player drops." );
					grouper_queued.push(match[ 1 ]);
				}
			} else {
				jmc.output( color( 1,"yellow") + "Ignoring :" + match[ 1 ] + " already exists in group");
				jmc.parse( "tell " + match[ 1 ] + " You have either already requested permission, or are already in the group." );
			}
		}
			
		if ((match = grouper_fol_start.exec( line )) != null) {
				var found = false;
				for (var x = 0; x < grouper_validate.length; x++) {
					if (match[ 1 ].search(/grouper_validate[ x ][ 0 ]/) != -1) {
						found = true;
						jmc.parse("gr " + grouper_validate[ x ][ 0 ]);
						grouper_grouped.push( grouper_validate[ x ][ 0 ] );
						grouper_validate[ x ] = null;
					}
				}
				if (!found)
					jmc.output( "Follower " + match[ 1 ] + " not found on list.");
				grouper_optimize();
		} else if ((match = grouper_fol_stop.exec( line )) != null) {
			var found = false;
			for (var x = 0; x < grouper_grouped.length; x++) {
				if (match[ 1 ].search(/grouper_grouped[ x ][ 0 ]/) != -1) {
					found = true;
					grouper_grouped[ x ] == null;
				}
			}
			if (found) {
				jmc.output( "" + match[ 1 ] + " stopped following");
				if (grouper_queued[ 0 ] != null) {
					grouper_validate.push( new Array( grouper_queued[ 0 ], new Date() ) );
					jmc.output( color( 1,"yellow") + grouper_queued[ 0 ] + " added to validation of group");
					jmc.parse( "tell " + grouper_queued[ 0 ] + " An opening is now available, you have 1 minute to follow or you will be removed from the queue list." );
				}
			}
			grouper_optimize();
		}
	}
	return event;
}


function grouper_optimize() {
	var temp = new Array();
	for (var x = 0; x < grouper_validate.length; x++) {
		if (grouper_validate[ x ] != null) {
			temp.push(grouper_validate[ x ]);
		}
	}
	grouper_validate = temp;
	var temp = new Array();
	for (var x = 0; x < grouper_grouped.length; x++) {
		if (grouper_grouped[ x ] != null) {
			temp.push(grouper_grouped[ x ]);
		}
	}
	grouper_grouped = temp;
	
	var temp = new Array();
	for (var x = 0; x < grouper_queued.length; x++) {
		if (grouper_queued[ x ] != null) {
			temp.push(grouper_queued[ x ]);
		}
	}
	grouper_queued = temp;
}

function grouper_onTimer() {
	var time = new Date();
	if (getElapseSeconds(grouper_check, time) > 5) {
		grouper_check = new Date();
		for (var x = 0; x < grouper_validate.length; x++) {
			if (getElapseSeconds(grouper_validate[ x ][ 1 ], time) > 60) {
				jmc.output( color( 1,"yellow") + "Removed :" + grouper_validate[ x ][ 0 ] + ", exceeded group time.");
				jmc.parse( "tell " + grouper_validate[ x ][ 0 ] + " You have been removed from my queue list, send me a tell when you're ready to follow." );
				grouper_validate[ x ] = null;
			}
		}
		grouper_optimize();
	}
}

function grouper_input() {
	event = jmc.event;
	switch (event) {
		default:
			split = event.split( " " );
			switch (split[ 0 ]) {
				case "/tog":
					switch (split[ 1 ]) {
						case "grouper":
							switch (grouper_enabled) {
								case 1:
									grouper_enabled = 0;
									jmc.output( "Grouper Disabled" );
								break;
								
								case 0:
									grouper_enabled = 1;
									jmc.output( "Grouper Enabled" );
								break;
							}
							return 1;
						break;
					}
				break;
			}
		break;
		
		case "/?":
		jmc.showme( "/tog grouper     - enables/disales grouper script");
		return 1;
		break;
	}
	return 0;
}

register_handler( "Incoming" , grouper_output);
register_handler( "Input" , grouper_input);
register_handler( "Timer" , grouper_onTimer);

jmc.output( "Grouper Loaded." );