/*	Project:	Stat Tracker
 *	Written by: Nemesis
 *	Date: 10/17/05
 *	Purpose:
 *		Prevents spam over channels
 */

var stat_increase = new RegExp( /^Your (\w+) has increased!/ );
var stats = new Array();

var stat_channel = "ct";
var stat_elapse = 10;

stats[ 'health' ] 	= 0;
stats[ 'mana' ] 		= 0;
stats[ 'spirit' ]		= 0;
stats[ 'endurance'] = 0;
stats[ 'practices' ] = 0;

stats[ 'strength' ] 		= 0; stats[ 'intellect' ] 		= 0;
stats[ 'constitution' ] = 0; stats[ 'wisdom' ] 				= 0;
stats[ 'dexterity' ] 		= 0; stats[ 'willpower' ] 		= 0;
stats[ 'agility' ] 			= 0; stats[ 'speed'] 					= 0;

var stat_time = null;
 
 function isInt(x) {
   var y=parseInt(x);
   if (isNaN(y)) return false;
   return x==y && x.toString()==y.toString();
 } 
 
function statTracker_incoming( event ) {
	line = remascii( event );
	if ((match = stat_increase.exec( line )) != null) {
		stats[ match[ 1 ] ]++;
		stat_time = new Date();
	}
	if (stat_time != null && (line.search( /^\[Reply:/ ) != -1 || line.search( /^\[Lag:/ ) != -1)) {
		var time = new Date();
		var elapse = getElapseSeconds( time, stat_time );
		if (elapse > stat_elapse) {
			stat_time = null;
			var output = "";
			for (var key in stats) {
				if (key == 'health' || key == 'mana' || key == 'spirit' || key == 'endurance' || key == 'practices') {
					if (stats[ key ]) {
						if (output)
							output += ", ";
						output += "+" + (stats[ key ] * 10) + " " + key;
						stats[ key ] = 0;
					}
				}
				else {
					if (isInt(stats[ key ]) == true && stats[ key ] != 0) {
						if (output)
							output += ", ";
						output += "+" + stats[ key ] + " " + key;
						stats[ key ] = 0;
					}
				}
			}
			jmc.send( stat_channel + " [ Gained ]: " + output );
		}
	}
	return event;
}

register_handler("Incoming", statTracker_incoming);